<?php

namespace Drupal\dynamic_routes\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\Route;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    $reg = '/\/user\/({user})|({uid})/';
    foreach ($collection->all() as $key => $route) {
      if (preg_match($reg, $route->getPath())) {
        $newroutename = $key . '.user.current';
        $newroute = preg_replace($reg, '/user/current', $route->getPath());
        $collection->add($newroutename, new Route(
          $newroute,
          [
            '_controller' => '\Drupal\dynamic_routes\Controller\ReRouter::content',
            '_title' => 'Resolving path...',
          ], [
            '_permission' => 'access content',
          ]
        ));
      }
    }
  }

}
